/*------------------------------------------------------------------------------
--  This file is a part of the libuc, microcontroler library
--  Copyright (C) 2012, Alexis Jeandet
--
--  This program is free software; you can redistribute it and/or modify
--  it under the terms of the GNU General Public License as published by
--  the Free Software Foundation; either version 3 of the License, or
--  (at your option) any later version.
--
--  This program is distributed in the hope that it will be useful,
--  but WITHOUT ANY WARRANTY; without even the implied warranty of
--  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
--  GNU General Public License for more details.
--
--  You should have received a copy of the GNU General Public License
--  along with this program; if not, write to the Free Software
--  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-------------------------------------------------------------------------------
--                 Author : Alexis Jeandet
--                   Mail : alexis.jeandet@gmail.com
-------------------------------------------------------------------------------*/
#ifndef STREAMDEVICES_H
#define STREAMDEVICES_H
#include <uhandle.h>
#include <stdint.h>

typedef struct streamdevice* streamdeviceptr;
struct streamdevice_ops;

typedef volatile struct streamdevice
{
    struct streamdevice_ops* ops;
    volatile uint32_t streamPt;
    volatile UHANDLE _stream;
    volatile uint32_t mode;
}streamdevice;


typedef struct streamdevice_ops
{
    int (*write)(streamdevice* device,void* data,int size, int n);
    int (*read)(streamdevice* device,void* data,int size, int n);
    int (*setpos)(streamdevice* device,int pos);
    int (*close)(streamdevice* device);
}streamdevice_ops;



typedef int (*write_t)(streamdeviceptr device,void* data,int size, int n);
typedef int (*read_t)(streamdeviceptr device,void* data,int size, int n);
typedef int (*setpos_t)(streamdeviceptr device,int pos);
typedef int (*close_t)(streamdeviceptr device);




#endif















